//<c>   Copyright 1997-1998 by Gerry J. Danen; all rights reserved.

//<t>   Doomsday Clock

//      /Q or /QUIET reduces output
//      /NT or /NOTIME changes the output format

#include"gd_tools.h"


#define pgVERS_ "V2.00"
#define pgTITL_ "Doomsday Clock"
#define pgCOPR_ "1997"


BOOL    ynQuiet = FALSE, ynTime = TRUE ;
INT32   target = 20000101L ;


void    main( int argc, char *argv[] )
{
    int         i ;
    long        years, days, hours, minutes, seconds ;
    INT32       ymd, hmst, tics, days2go ;
    INT16       y, m, d, hh, mm, ss, tt ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );

    argc -= 1 ;
    LOOP( i, 1, argc, 1 )                       // process arguments
    {
        if ( st_eq( argv[i], "/quiet") ||
             st_eq( argv[i], "/q"    ) ||
             st_eq( argv[i], "quiet" ) ||
             st_eq( argv[i], "q"     ) )
            ynQuiet = TRUE ;
        if ( st_eq( argv[i], "/notime") ||
             st_eq( argv[i], "/nt"    ) ||
             st_eq( argv[i], "notime" ) ||
             st_eq( argv[i], "nt"     ) )
            ynTime = FALSE ;
    }
    if ( ! ynQuiet )
        logon(0);

    if ( dt_getsystemdate( &ymd, &y, &m, &d ) != OK )
    {
        printf( "Illegal system date\n" );
        exit( BAD_EXIT );
    }
    if ( y < 1998 || y > 2000 )
    {
        printf( "Irrelevant system date. Must be 1998 or 1999.\n" );
        exit( BAD_EXIT );
    }

    days2go = DaysBetween( ymd, target );

    if ( ymd == target )
    {
        printf( "Today is January 1, 2000!" );
        if ( ! ynQuiet )
            printf( "\n" );
        exit( GOOD_EXIT );
    }

    if ( ymd < target )
    {
        long dif, now, midnight = (24L * 60L * 60L) ;

        if ( tm_getsystemtime( &hmst, &tics, &hh, &mm, &ss, &tt ) != OK )
        {
            printf( "Illegal system time\n" );
            exit( BAD_EXIT );
        }
        now     = ((long)hh * 3600L) + ((long)mm * 60L) + ss ;
        dif     = midnight - now - 1 ;
        hours   = dif / 3600 ;
        dif     = dif - (hours * 3600) ;
        minutes = dif / 60 ;
        seconds = dif - (minutes * 60) ;

        if ( ynTime )
            days2go -= 1 ;                      // not a full day, as we're showing time now...
        years = (int)(days2go / 365L);
        days  = days2go - (years * 365);
        if ( ynTime )
        {
            if ( years )
            {
                printf( "%ld year%s, %ld day%s, "
                        "%ld hour%s, %ld minute%s, and %ld second%s "
                        "until January 1, 2000.",
                        years  , (years   == 1 ? "" : "s"),
                        days   , (days    == 1 ? "" : "s"),
                        hours  , (hours   == 1 ? "" : "s"),
                        minutes, (minutes == 1 ? "" : "s"),
                        seconds, (seconds == 1 ? "" : "s") );
            }
            else
            {
                printf( "%ld day%s, "
                        "%ld hour%s, %ld minute%s, and %ld second%s "
                        "until January 1, 2000.",
                        days   , (days    == 1 ? "" : "s"),
                        hours  , (hours   == 1 ? "" : "s"),
                        minutes, (minutes == 1 ? "" : "s"),
                        seconds, (seconds == 1 ? "" : "s") );
            }
        }
        else
        {
            if ( years )
            {
                printf( "%ld year%s and %ld day%s "
                        "until January 1, 2000.",
                        years  , (years   == 1 ? "" : "s"),
                        days   , (days    == 1 ? "" : "s") );
            }
            else
            {
                printf( "%ld day%s until January 1, 2000.",
                        days, (days == 1 ? "" : "s") );
            }
        }
        if ( ! ynQuiet )
            printf( "\n" );
        if ( (ynTime && days2go == 0) || ((!ynTime) && days2go == 1) )
            printf( "\nTomorrow is the big day!\n\n" );
    }
    else
        printf( "We've already passed the magic moment...\n" );

    exit( GOOD_EXIT );
}
